



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>字符串匹配算法——BF、KMP、Sunday</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">字符串匹配算法——BF、KMP、Sunday</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 11:46:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一：<strong>Brute force</strong></p>
<p>从源串的第一个字符开始扫描，逐一与模式串的对应字符进行匹配，若该组字符匹配，则检测下一组字符，如遇失配，则退回到源串的第二个字符，重复上述步骤，直到整个模式串在源串中找到匹配，或者已经扫描完整个源串也没能够完成匹配为止。</p>
<p>缺点：假如我们从头开始匹配str1和str2，当匹配到str1[i]时，发现str2[i]！=str1[i]，这时我们就回到str1<strong>起始匹配的地方</strong>，把str2<strong>右移一位</strong>，<strong>对准str1下一字符</strong>作为起点，进行匹配。由于上一次匹配到了str1[i]，那么重新开始匹配时，<strong>新匹配起点~str1[i]这段子串又要被重新匹配</strong>。</p>
<p><strong>二：KMP</strong></p>
<p>暴力搜索的缺点在于单纯地从原来匹配起点右移一位重新匹配，效率低下并且没有<strong>好好利用上一次匹配时得出的有效信息</strong>。</p>
<p>KMP算法的出发点为：从上一次匹配过程中，检测出有效信息，使下一次匹配不是单纯地右移一位开始匹配，而是<strong>跳过一段不必要尝试的子串</strong>，直接<strong>从下一有可能匹配成功的起点</strong>开始匹配。</p>
<p>概念准备：</p>
<p>前缀：字符串A = "abcde"，那么a,ab,abc,abcd,abcde都是A的前缀，前缀其实就是字符串A从左往右、从头开始依次取长度为1、2、3...str.length()的子串。</p>
<p>后缀：字符串A = "abcde"，那么abcde,bcde,cde,de,e都是A的后缀，同理，后缀就是依次从A的开头、第二位，第三位...最后一位开始截取，取到尾部的子串。</p>
<p>真前缀、真后缀：即不<strong>等于字符串本身</strong>的前缀、后缀子串。</p>
<p>kmp算法的核心:</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1018541/201705/1018541-20170514111546597-1082653828.png" /></p>
<p>计算字符串f每一个<strong>位置之前</strong>的子串的<strong>前缀和真后缀公共部分的最大长度</strong>（不包括子串本身，否则最大长度始终是子串本身）。当每次比较到两个字符串的字符不同时，我们就可以根据当前比较位置的最大公共长度将字符串f<strong>右移(已匹配长度-最大公共长度)</strong>位，重新开始匹配。</p>
<p>我们把查找的字符串成为模式串，KMP算法的代码实际上分两部分：</p>
<p>1：预处理模式串，得到next[]数组（next数组为：对于<strong>模式串</strong>的每一位j，当位j与主串不匹配时，模式串下一个匹配起点是模式串中的哪位）；【相对移动，这里不求最大长度和模式串右移多少位，而是直接求模式串右移后，新的匹配的起点的位置（因为右移后，前缀是匹配的，所以不是从模式串开头进行匹配，而是<strong>从前缀的后一位开始</strong>）】</p>
<p>2：匹配字符串，每当匹配到不相同位时，使用next[]得到<strong>模式串下一个用来匹配的起点</strong>；</p>
<div>
<pre class="prettyprint linenums"> public static int[] next(char[] t) {<br />
        int[] next = new int[t.length];<br />
        next[0] = -1;<br />
        int i = 0;<br />
        int j = -1;<br />
        while (i &lt; t.length - 1) {<br />
            if (j == -1 || t[i] == t[j]) {<br />
                i++;<br />
                j++;<br />
                if (t[i] != t[j]) {<br />
                    next[i] = j;<br />
                } else {<br />
                    next[i] = next[j];<br />
                }<br />
            } else {<br />
                j = next[j];<br />
            }<br />
        }<br />
        return next;<br />
    }  

 public static int KMP_Index(char[] s, char[] t) {<br />
        int[] next = next(t);<br />
        int i = 0;<br />
        int j = 0;<br />
        while (i &lt;= s.length - 1 &amp;&amp; j &lt;= t.length - 1) {<br />
            if (j == -1 || s[i] == t[j]) {<br />
                i++;<br />
                j++;<br />
            } else {<br />
                j = next[j];<br />
            }<br />
        }<br />
        if (j &lt; t.length) {<br />
            return -1;<br />
        } else<br />
            return i - t.length; // 返回模式串在主串中的头下标<br />
    }  </pre>
</div>
<p>三：<strong>Sunday</strong></p>
<p>简单、快速的匹配算法。</p>
<p>思路如下：摘自：http://blog.csdn.net/laojiu_/article/details/50767615</p>
<p>假设我们有如下字符串：<br />A = "LESSONS TEARNED IN SOFTWARE TE";<br />B = "SOFTWARE";<br />Sunday算法的大致原理是：<br />先从左到右，两个字符串逐个字符比较，<strong>i指向主串下标，j指向模式串下标</strong>；<br />开始的时候，我们让i = 0, 指向A的第一个字符; j = 0 指向B的第一个字符，分别为"L"和"S"，不等；这个时候，找到位于<strong>A字串中位于B字符串长度后面的第一个字符，下标为m</strong>，即下图字符"T"，然后<strong>在模式字符串B中从后向前查找是否存在"T"；</strong></p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160714221937697" /></p>
<p>可以看到下图模式串的T，<strong>下标为k</strong>；<br /><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160714222222080" /></p>
<p>将相等的字符对齐（对齐的方法为：<strong>令i移动，j仍指向模式串开头</strong>）：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160714222349968" /></p>
<p>再次比较A[i]和B[j]，不等，这时再次寻找主串中在模式串后面的那个字符，</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160714222451518" /></p>
<p>我们看到，模式串的最后一个字符与m指向的主串字符相等，再次对齐</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160714222940914" /></p>
<p>这时，主串i对应的字符是S，j对应的子串字符也是S。则<strong>逐位比较，同步移动下标</strong>：i++, j++</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160714223051525" /></p>
<p>现在再次不等，找到A中的m，指向字符"D"，</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160714223156855" /></p>
<p>代码实现：</p>
<div>
<pre class="prettyprint linenums">    //从后向前寻找目标字符下标<br />
    private int contains(char[] chars,char target){<br />
        for(int i = chars.length-1 ; i &gt;= 0; i--){<br />
            if(chars[i] == target){<br />
                return i ;<br />
            }<br />
        }<br />
        return -1;<br />
    }

   //sunday算法<br />
    public int Sunday(String dest , String pattern){

        char[] destchars = dest.toCharArray();<br />
        char[] patternchars = pattern.toCharArray();

        int i = 0;<br />
        int j = 0;<br />
        //控制边界<br />
        while(i &lt;= (dest.length() - pattern.length() + j )  ){<br />
            if( destchars[i] != patternchars[j] ){//对应位不相同<br />
                if(i == (dest.length() - pattern.length() + j )){//已经末尾对齐<br />
                    return -1;<br />
                }<br />
                //还未到主串末尾，则继续下面操作<br />
                //在模式串中。查找主串中对应模式串末尾的下一位字符在模式串中的下标<br />
                int pos = contains(patternchars,destchars[i+pattern.length()-j]);<br />
                if( pos== -1){//若没有，则直接把模式串对齐末尾的下一位<br />
                    i = i + (pattern.length()  - j)+1;<br />
                    j = 0 ;<br />
                }else{<br />
                    i = i + (pattern.length() - j)-pos;<br />
                    j = 0;<br />
                }<br />
            }else{//对应位相同<br />
                if(j == (pattern.length() - 1)){//如果对应位已经到达模式串末尾，则匹配成功<br />
                  return  i-j+1;<br />
                }else{//未到末尾，则比较下一位<br />
                    i++;<br />
                    j++;<br />
                }<br />
            }<br />
        }<br />
    }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zoy7dq.html">linux下编译gcc6&period;2&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96rnon9.html">Java 基本数据类型长度</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wkwgvq.html">Java学习一</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m2lojq.html">css3 transition 实现图片放大缩小</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1erx19.html">netty 实现socket服务端编写</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y5yxnq.html">hdoj 1200 To and Fro</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o23g49.html">基于RMAN从活动数据库异机克隆&lpar;rman duplicate from active DB&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn7pnz8.html">iOS7 StatusBar 使用小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjz00g8.html">面向对象，更适合JavaScript</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp2d17q.html">你的知识需要管理PKM</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvn6128.html">LDAP概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oep6e8.html">通过 Systemd Journal 收集日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ry1mz8.html">solr6&period;4&period;1搜索引擎&lpar;5&rpar;使用zookeeper3&period;4&period;9分布式集群</a>
		</li>
						<li><a href="https://www.batexi.com/a/960g5e49.html">&lbrack;UWP 自定义控件&rsqb;了解模板化控件&lpar;5&rpar;：VisualState</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnd4y7q.html">linux开启swap（磁盘缓存）操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/963m7jy9.html">Google TensorFlow 机器学习框架介绍和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql176569.html">Intel&amp;&num;174&semi; Core&trade; i5-5300U Processor</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjz37o8.html">什么是C&plus;&plus;虚函数、虚函数的作用和使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvep0ej9.html">Mysql&colon; Connect&sol;C&plus;&plus; 使用过程中发现返回 std&colon;&colon;string 造成的内存泄露</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlp4m39.html">JavaScript DOM 第3章 DOM</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1vk4j2q.html">java数字转换成文字方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjek7o8.html">多个so中模板单例的多次实例化</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1jp319.html">图像质量评估（IQA）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjpry0q.html">tf&period;transpose函数的用法讲解</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmzd509.html">Unicode 和 UTF-8 的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmzxw09.html">delete method not allowed 405错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv1omgq.html">SQLServer中merge函数用法详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vk2mzq.html">nodejs中thiskeyword的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjp1m0q.html">MySql 5&period;7安装（随机密码，修改默认密码）两个坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4j021q.html">tensorflow项目构建流程</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
